"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkDuplicateKeys = exports.getPluralFunc = exports.makePluralFunc = exports.buildArr = exports.buildStr = exports.msgid2Orig = exports.getMsgid = void 0;
exports.getMsgid = function (str, exprs) {
    var result = [];
    var exprsLenght = exprs.length;
    var strLength = str.length;
    for (var i = 0; i < strLength; i++) {
        var expr = i < exprsLenght ? "${" + i + "}" : "";
        result.push(str[i] + expr);
    }
    return result.join("");
};
var stringableRewindingIterator = function () { return ({
    values: [],
    index: -1,
    toString: function () {
        this.index = (this.index + 1) % this.values.length;
        return this.values[this.index].toString();
    }
}); };
var removeSpaces = function (str) { return str.replace(/\s/g, ""); };
var mem = {};
// eslint-disable-next-line no-unused-vars
var memoize1 = function (f) { return function (arg) {
    if (mem[arg]) {
        return mem[arg];
    }
    mem[arg] = f(arg);
    return mem[arg];
}; };
var reg = function (i) {
    return new RegExp("\\$\\{(?:[\\s]+?|\\s?)" + i + "(?:[\\s]+?|\\s?)}");
};
var memReg = memoize1(reg);
exports.msgid2Orig = function (id, exprs) {
    return exprs.reduce(function (r, expr, i) { return r.replace(memReg(String(i)), String(expr)); }, id);
};
exports.buildStr = function (strs, exprs) {
    var exprsLength = exprs.length - 1;
    return strs.reduce(function (r, s, i) { return r + s + (i <= exprsLength ? exprs[i] : ""); }, "");
};
exports.buildArr = function (strs, exprs) {
    return strs.reduce(function (r, s, i) {
        return exprs[i] !== undefined ? r.concat(s, exprs[i]) : r.concat(s);
    }, []);
};
function pluralFnBody(pluralStr) {
    return "return args[+ (" + pluralStr + ")];";
}
var fnCache = {};
function makePluralFunc(pluralStr) {
    var fn = fnCache[pluralStr];
    if (!fn) {
        fn = new Function("n", "args", pluralFnBody(pluralStr));
        fnCache[pluralStr] = fn;
    }
    return fn;
}
exports.makePluralFunc = makePluralFunc;
var pluralRegex = /\splural ?=?([\s\S]*);?/;
function getPluralFunc(headers) {
    var _a;
    var pluralFormsHeader = headers["plural-forms"] || headers["Plural-Forms"];
    if (!pluralFormsHeader) {
        throw new Error('po. data should include "language" or "plural-form" header for ngettext');
    }
    var pluralFn = ((_a = pluralRegex.exec(pluralFormsHeader)) === null || _a === void 0 ? void 0 : _a[1]) || [];
    if (pluralFn[pluralFn.length - 1] === ";") {
        pluralFn = pluralFn.slice(0, -1);
    }
    return pluralFn;
}
exports.getPluralFunc = getPluralFunc;
var variableREG = /\$\{\s*([.\w+\[\]])*\s*\}/g;
function getObjectKeys(obj) {
    var e_1, _a;
    var keys = [];
    try {
        for (var _b = __values(Object.entries(obj)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 1), key = _d[0];
            if (obj.hasOwnProperty(key)) {
                keys.push(key);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return keys;
}
function replaceVariables(str, obj) {
    return str.replace(variableREG, function (variable) {
        return "${" + obj[removeSpaces(variable)] + "}";
    });
}
function getVariablesMap(msgid) {
    var variableNumberMap = {};
    var variables = msgid.match(variableREG);
    if (!variables)
        return null;
    for (var i = 0; i < variables.length; i++) {
        var k = removeSpaces(variables[i]);
        variableNumberMap[k] =
            variableNumberMap[k] || stringableRewindingIterator();
        variableNumberMap[k].values.push(i);
    }
    return variableNumberMap;
}
function transformCompactTranslate(msgid) {
    var variableNumberMap = getVariablesMap(msgid);
    if (!variableNumberMap) {
        return msgid;
    }
    return replaceVariables(msgid, variableNumberMap);
}
function findDuplicatingMsgid(msgids, transformedMsgid) {
    return msgids.find(function (msgid) {
        var variableNumberMap = getVariablesMap(msgid);
        if (!variableNumberMap) {
            return false;
        }
        return replaceVariables(msgid, variableNumberMap) === transformedMsgid;
    });
}
function checkDuplicateKeys(poData) {
    var ctxKeys = getObjectKeys(poData.translations);
    for (var i = 0; i < ctxKeys.length; i++) {
        var ctx = ctxKeys[i];
        var transformedMsgids = new Set();
        var msgids = getObjectKeys(poData.translations[ctx]);
        for (var j = 0; j < msgids.length; j++) {
            var msgid = msgids[j];
            var newMsgid = transformCompactTranslate(msgid); // msgid where vars replaced by number t`test ${num1}`  => t`test ${0}`
            if (transformedMsgids.has(newMsgid)) {
                var duplicatedMsgid = findDuplicatingMsgid(msgids, newMsgid);
                return ("Duplicate msgid (\"" + msgid + "\" and \"" + duplicatedMsgid + "\" in the same context will be interpreted as the same key \"" + newMsgid + "\") this potentially can lead to translation loss." +
                    " Consider using deferent context for one of those msgid's. See the context doc here - https://ttag.js.org/docs/context.html");
            }
            transformedMsgids.add(newMsgid);
        }
    }
    return null;
}
exports.checkDuplicateKeys = checkDuplicateKeys;
